/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3) 
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details. 
 */

package org.dive4elements.river.client.shared.model;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class DefaultTheme implements Theme {

    protected int position;

    protected int index;

    protected int active;

    protected int visible;

    protected String artifact;

    protected String facet;

    protected String description;

    /** CollectionItem associated with this facet/themes artifact. */
    protected CollectionItem collectionItem;


    public DefaultTheme() {
    }


    public DefaultTheme(
        int     pos,
        int     index,
        int     active,
        int     visible,
        String  art,
        String  facet,
        String  description)
    {
        this.position       = pos;
        this.index          = index;
        this.active         = active;
        this.visible        = visible;
        this.artifact       = art;
        this.facet          = facet;
        this.description    = description;
        this.collectionItem = null;
    }


    public int getPosition() {
        return position;
    }


    public void setPosition(int pos) {
        this.position = pos;
    }


    public int getIndex() {
        return index;
    }


    public int getActive() {
        return active;
    }


    public void setActive(int active) {
        this.active = active;
    }


    public String getArtifact() {
        return artifact;
    }


    public String getFacet() {
        return facet;
    }


    public String getDescription() {
        return description;
    }


    public void setDescription(String description) {
        this.description = description;
    }


    public int getVisible() {
        return visible;
    }


    public void setVisible(int visible) {
        this.visible = visible;
    }


    public boolean equals(Object o) {
        if (!(o instanceof DefaultTheme)) {
            return false;
        }

        DefaultTheme other = (DefaultTheme) o;

        if (other.position != position) {
            return false;
        }

        if (!other.artifact.equals(artifact)) {
            return false;
        }

        if (other.active != active) {
            return false;
        }

        if (!other.facet.equals(facet)) {
            return false;
        }

        if (!other.description.equals(description)) {
            return false;
        }

        if (other.index != index) {
            return false;
        }

        if (other.visible != visible) {
            return false;
        }

        return true;
    }

    /** Get the CollectionItem representing the facets artifact. */
    @Override
    public CollectionItem getCollectionItem() {
        return collectionItem;
    }

    /** Set the CollectionItem representing the facets artifact. */
    @Override
    public void setCollectionItem(CollectionItem ci) {
        this.collectionItem = ci;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
